// ChannelList.H  -*- C++ -*-
// Copyright (c) 1997, 1998 Etienne BERNARD
// Copyright (C) 2002 Clinton Ebadi

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
// 02110-1301, USA.

#ifndef CHANNELLIST_H
#define CHANNELLIST_H

#include <map>

#include "Channel.H"
#include "String.H"

class UserCommands;
class ServerConnection;

class ChannelList {
  std::map<String, Channel *, std::less<String> > channel_list;
  
public:
  ChannelList();
  ~ChannelList();

  void addChannel(ServerConnection *, String, String = "");
  void delChannel(String);
  
  Channel * getChannel(String);

  void clear();

  std::map<String, Channel *, std::less<String> >::iterator begin()
    { return channel_list.begin(); }
  std::map<String, Channel *, std::less<String> >::iterator end()
    { return channel_list.end(); }

  friend class UserCommands;
};

#endif
