// Interp.H  -*- C++ -*-
// Copyright (c) 1998 Etienne BERNARD
// Copyright (c) 2002,2005 Clinton Ebadi

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
// 02110-1301, USA.

#ifndef INTERP_H
#define INTERP_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef USESCRIPTS

#include <libguile.h>

#ifdef MULTITHREAD
#include <pthread.h>
#endif

#include "String.H"

class Bot;

struct wrapper_data {
  SCM func;
  SCM args;
};

class Interp {
public:
  static Bot *bot;
  static SCM bot_module;
#ifdef MULTITHREAD
private:
  static pthread_mutex_t mutex;
#endif
public:
  static void Startup();
  static void Startup2 (Bot *b);
  static void Shutdown();
  static void Execute(Bot *, String);
  static void LoadScript(Bot *, String);

  static SCM LazyApplyWrapper (void *);
  static SCM EmptyHandler (void *, SCM, SCM);
  static SCM LazyHandler (void *, SCM, SCM);
  static SCM ScmApplyWrapper (void *);
};

#endif
#endif
